/*
 * Copyright (c) 1997 - 1999 by Sun Microsystems, Inc.
 * All rights reserved.
 */

%#pragma ident	"@(#)getpeerinfo.x	6.1	99/11/16 SMI; TSOL 2.x"

%#include <sys/param.h>

/* because there are no XDR types for these */
typedef	unsigned int	p_uint_t;
typedef	p_uint_t	p_dev_t;
typedef int		p_uid_t;
typedef	p_uid_t		p_gid_t;
typedef	p_uid_t		p_au_id_t;
typedef	int		p_pid_t;
typedef	p_pid_t		p_au_asid_t;

struct p_au_tid {		/* should be au_tid, but no xdr for it */
	p_dev_t		port;
	p_uint_t	machine;
};

struct p_au_mask {		/* should be au_mask, but ... */
	p_uint_t	am_success;
	p_uint_t	am_failure;
};

struct p_auditinfo {		/* should be auditinfo, but, ... */
	p_au_id_t	ai_auid;
	p_au_mask	ai_mask;
	p_au_tid	ai_termid;
	p_au_asid_t	ai_asid;
};

struct p_au_peergroupinfo {
	p_uint_t	peer_ngroups;
	p_gid_t		peer_groups[NGROUPS_UMAX];
};

struct p_au_peermiscinfo {
	p_uid_t		peer_ruid;
	p_gid_t		peer_rgid;
	p_auditinfo	peer_audit;
};

struct pinfo {
	p_au_peergroupinfo	grpinfo;
	p_au_peermiscinfo	prinfo;
};

enum info_type {
	GRPINFO,
	AUDINFO,
	ALLINFO
};

typedef enum info_type info_type;

union peerinfo_res switch (int rpcerrno) {
case 0:
	pinfo info;
default:
	void;
};

struct peerinfo_arg {
	p_pid_t	pid;
};

struct peerinfo_arg2 {
	p_pid_t	pid;
	info_type type;
};

program PEERINFOPROG {
	version PEERINFOVERS {
		peerinfo_res GETPEERINFO(peerinfo_arg) = 1;
	} = 1;

	version PEERINFOVERS2 {
		peerinfo_res GETPEERINFO(peerinfo_arg2) = 1;
	} = 2;
} = 110002;
